---
title: Using CSS animations
slug: Web/CSS/CSS_Animations/Using_CSS_animations
tags:
  - Advanced
  - CSS
  - CSS Animations
  - Example
  - Guide
---
<p>{{CSSRef}}</p>

<p><span class="seoSummary"><strong>CSS animations</strong> make it possible to animate transitions from one CSS style configuration to another.</span> Animations consist of two components, a style describing the CSS animation and a set of keyframes that indicate the start and end states of the animation’s style, as well as possible intermediate waypoints.</p>

<p>There are three key advantages to CSS animations over traditional script-driven animation techniques:</p>

<ol>
 <li>They’re easy to use for simple animations; you can create them without even having to know JavaScript.</li>
 <li>The animations run well, even under moderate system load. Simple animations can often perform poorly in JavaScript. The rendering engine can use frame-skipping and other techniques to keep the performance as smooth as possible.</li>
 <li>Letting the browser control the animation sequence lets the browser optimize performance and efficiency by, for example, reducing the update frequency of animations running in tabs that aren't currently visible.</li>
</ol>

<h2 id="Configuring_the_animation">Configuring the animation</h2>

<p>To create a CSS animation sequence, you style the element you want to animate with the {{cssxref("animation")}} property or its sub-properties. This lets you configure the timing, duration, and other details of how the animation sequence should progress. This does <strong>not</strong> configure the actual appearance of the animation, which is done using the {{cssxref("@keyframes")}} at-rule as described in {{anch("Defining the animation sequence using keyframes")}} below.</p>

<p>The sub-properties of the {{cssxref("animation")}} property are:</p>

<dl>
 <dt>{{cssxref("animation-name")}}</dt>
 <dd>Specifies the name of the {{cssxref("@keyframes")}} at-rule describing the animation’s keyframes.</dd>
 <dt>{{cssxref("animation-duration")}}</dt>
 <dd>Configures the length of time that an animation should take to complete one cycle.</dd>
 <dt>{{cssxref("animation-timing-function")}}</dt>
 <dd>Configures the timing of the animation; that is, how the animation transitions through keyframes, by establishing acceleration curves.</dd>
 <dt>{{cssxref("animation-delay")}}</dt>
 <dd>Configures the delay between the time the element is loaded and the beginning of the animation sequence.</dd>
 <dt>{{cssxref("animation-iteration-count")}}</dt>
 <dd>Configures the number of times the animation should repeat; you can specify <code>infinite</code> to repeat the animation indefinitely.</dd>
 <dt>{{cssxref("animation-direction")}}</dt>
 <dd>Configures whether or not the animation should alternate direction on each run through the sequence or reset to the start point and repeat itself.</dd>
 <dt>{{cssxref("animation-fill-mode")}}</dt>
 <dd>Configures what values are applied by the animation before and after it is executing.</dd>
 <dt>{{cssxref("animation-play-state")}}</dt>
 <dd>Lets you pause and resume the animation sequence.</dd>
</dl>

<h2 id="Defining_the_animation_sequence_using_keyframes">Defining the animation sequence using keyframes</h2>

<p>Once you’ve configured the animation’s timing, you need to define the appearance of the animation. This is done by establishing two or more keyframes using the {{cssxref("@keyframes")}} at-rule. Each keyframe describes how the animated element should render at a given time during the animation sequence.</p>

<p>Since the timing of the animation is defined in the CSS style that configures the animation, keyframes use a {{cssxref("percentage")}} to indicate the time during the animation sequence at which they take place. 0% indicates the first moment of the animation sequence, while 100% indicates the final state of the animation. Because these two times are so important, they have special aliases: <code>from</code> and <code>to</code>. Both are optional. If <code>from</code>/<code>0%</code> or <code>to</code>/<code>100%</code> is not specified, the browser starts or finishes the animation using the computed values of all attributes.</p>

<p>You can optionally include additional keyframes that describe intermediate steps between the start and end of the animation.</p>

<h2 id="Examples">Examples</h2>

<div class="note"><strong>Note:</strong> Some older browsers (pre-2017) may need prefixes; the live examples you can click to see in your browser include the <code>-webkit</code> prefixed syntax.</div>

<h3 id="Making_text_slide_across_the_browser_window">Making text slide across the browser window</h3>

<p>This simple example styles the {{HTMLElement("p")}} element so that the text slides in from off the right edge of the browser window.</p>

<p>Note that animations like this can cause the page to become wider than the browser window. To avoid this problem put the element to be animated in a container, and set {{cssxref("overflow")}}<code>:hidden</code> on the container.</p>

<pre class="brush: css notranslate">p {
  animation-duration: 3s;
  animation-name: slidein;
}

@keyframes slidein {
  from {
    margin-left: 100%;
    width: 300%;
  }

  to {
    margin-left: 0%;
    width: 100%;
  }
}
</pre>

<p>In this example the style for the {{HTMLElement("p")}} element specifies that the animation should take 3 seconds to execute from start to finish, using the {{cssxref("animation-duration")}} property, and that the name of the {{ cssxref("@keyframes")}} at-rule defining the keyframes for the animation sequence is named “slidein”.</p>

<p>If we wanted any custom styling on the {{HTMLElement("p")}} element to appear in browsers that don’t support CSS animations, we would include it here as well; however, in this case we don’t want any custom styling other than the animation effect.</p>

<p>The keyframes are defined using the {{cssxref("@keyframes")}} at-rule. In this case, we have just two keyframes. The first occurs at 0% (using the alias <code>from</code>). Here, we configure the left margin of the element to be at 100% (that is, at the far right edge of the containing element), and the width of the element to be 300% (or three times the width of the containing element). This causes the first frame of the animation to have the header drawn off the right edge of the browser window.</p>

<p>The second (and final) keyframe occurs at 100% (using the alias <code>to</code>). The left margin is set to 0% and the width of the element is set to 100%. This causes the header to finish its animation flush against the left edge of the content area.</p>

<pre class="brush: html notranslate">&lt;p&gt;The Caterpillar and Alice looked at each other for some time in silence:
at last the Caterpillar took the hookah out of its mouth, and addressed
her in a languid, sleepy voice.&lt;/p&gt;
</pre>

<div class="notecard note">
<p><strong>Note</strong>: Reload page to see the animation, or click the CodePen button to see the animation in the CodePen environment.</p>
</div>

<p>{{EmbedLiveSample("Making_text_slide_across_the_browser_window","100%","250")}}</p>

<h3 id="Adding_another_keyframe">Adding another keyframe</h3>

<p>Let’s add another keyframe to the previous example’s animation. Let’s say we want the header’s font size to increase as it moves from right to left for a while, then to decrease back to its original size. That’s as simple as adding this keyframe:</p>

<pre class="brush: css notranslate">75% {
  font-size: 300%;
  margin-left: 25%;
  width: 150%;
}
</pre>

<p>The full code now looks like this:</p>

<pre class="brush: css notranslate">p {
  animation-duration: 3s;
  animation-name: slidein;
}

@keyframes slidein {
  from {
    margin-left: 100%;
    width: 300%;
  }

  75% {
    font-size: 300%;
    margin-left: 25%;
    width: 150%;
  }

  to {
    margin-left: 0%;
    width: 100%;
  }
}
</pre>

<pre class="brush: html notranslate">&lt;p&gt;The Caterpillar and Alice looked at each other for some time in silence:
at last the Caterpillar took the hookah out of its mouth, and addressed
her in a languid, sleepy voice.&lt;/p&gt;
</pre>

<p>This tells the browser that 75% of the way through the animation sequence, the header should have its left margin at 25% and the width should be 150%.</p>

<div class="notecard note">
<p><strong>Note</strong>: Reload page to see the animation, or click the CodePen button to see the animation in the CodePen environment.</p>
</div>

<p>{{EmbedLiveSample("Adding_another_keyframe","100%","250")}}</p>

<h3 id="Making_it_repeat">Making it repeat</h3>

<p>To make the animation repeat itself, use the {{cssxref("animation-iteration-count")}} property to indicate how many times to repeat the animation. In this case, let’s use <code>infinite</code> to have the animation repeat indefinitely:</p>

<pre class="brush: css notranslate">p {
  animation-duration: 3s;
  animation-name: slidein;
  animation-iteration-count: infinite;
}
</pre>

<p>Adding it to the existing code:</p>

<pre class="brush: css notranslate">@keyframes slidein {
  from {
    margin-left: 100%;
    width: 300%;
  }

  to {
    margin-left: 0%;
    width: 100%;
  }
}
</pre>

<pre class="brush: html notranslate">&lt;p&gt;The Caterpillar and Alice looked at each other for some time in silence:
at last the Caterpillar took the hookah out of its mouth, and addressed
her in a languid, sleepy voice.&lt;/p&gt;
</pre>

<p>{{EmbedLiveSample("Making_it_repeat","100%","250")}}</p>

<h3 id="Making_it_move_back_and_forth">Making it move back and forth</h3>

<p>That made it repeat, but it’s very odd having it jump back to the start each time it begins animating. What we really want is for it to move back and forth across the screen. That’s easily accomplished by setting {{cssxref("animation-direction")}} to <code>alternate</code>:</p>

<pre class="brush: css notranslate">p {
  animation-duration: 3s;
  animation-name: slidein;
  animation-iteration-count: infinite;
  animation-direction: alternate;
}
</pre>

<p>And the rest of the code:</p>

<pre class="brush: css notranslate">@keyframes slidein {
  from {
    margin-left: 100%;
    width: 300%;
  }

  to {
    margin-left: 0%;
    width: 100%;
  }
}
</pre>

<pre class="brush: html notranslate">&lt;p&gt;The Caterpillar and Alice looked at each other for some time in silence:
at last the Caterpillar took the hookah out of its mouth, and addressed
her in a languid, sleepy voice.&lt;/p&gt;
</pre>

<p>{{EmbedLiveSample("Making_it_move_back_and_forth","100%","250")}}</p>

<h3 id="Using_animation_shorthand">Using animation shorthand</h3>

<p>The {{cssxref("animation")}} shorthand is useful for saving space. As an example, the rule we’ve been using through this article:</p>

<pre class="brush: css notranslate">p {
  animation-duration: 3s;
  animation-name: slidein;
  animation-iteration-count: infinite;
  animation-direction: alternate;
}
</pre>

<p>Could be replaced by</p>

<pre class="brush: css notranslate">p {
  animation: 3s infinite alternate slidein;
}
</pre>

<div class="note">
<p><strong>Note</strong>: You can find more details out at the {{cssxref("animation")}} reference page:</p>
</div>

<h3 id="Setting_multiple_animation_property_values">Setting multiple animation property values</h3>

<p>The CSS animation longhand values can accept multiple values, separated by commas — this feature can be used when you want to apply multiple animations in a single rule, and set separate durations, iteration counts, etc. for the different animations. Let’s look at some quick examples to explain the different permutations:</p>

<p>In this first example, we have three animation names set, but only one duration and iteration count. In this case all three animations are given the same duration and iteration count:</p>

<pre class="brush: css notranslate">animation-name: fadeInOut, moveLeft300px, bounce;
animation-duration: 3s;
animation-iteration-count: 1;</pre>

<p>In this second example, we have three values set on all three properties. In this case each animation is run with the corresponding values in the same position on each property, so for example <code>fadeInOut</code> has a duration of 2.5s and an iteration count of 2, etc.</p>

<pre class="brush: css notranslate">animation-name: fadeInOut, moveLeft300px, bounce;
animation-duration: 2.5s, 5s, 1s;
animation-iteration-count: 2, 1, 5;</pre>

<p>In this third case, there are three animations specified, but only two durations and iteration counts. In such cases where there are not enough values to give a separate value to each animation, the values cycle from start to finish. So for example, fadeInOut gets a duration of 2.5s and moveLeft300px gets a duration of 5s. We’ve now got to the end of the available duration values, so we start from the beginning again — bounce therefore gets a duration of 2.5s. The iteration counts (and any other property values you specify) will be assigned in the same way.</p>

<pre class="brush: css notranslate">animation-name: fadeInOut, moveLeft300px, bounce;
animation-duration: 2.5s, 5s;
animation-iteration-count: 2, 1;</pre>

<h3 id="Using_animation_events">Using animation events</h3>

<p>You can get additional control over animations — as well as useful information about them — by making use of animation events. These events, represented by the {{domxref("AnimationEvent")}} object, can be used to detect when animations start, finish, and begin a new iteration. Each event includes the time at which it occurred as well as the name of the animation that triggered the event.</p>

<p>We'll modify the sliding text example to output some information about each animation event when it occurs, so we can get a look at how they work.</p>

<h4 id="Adding_the_CSS">Adding the CSS</h4>

<p>We start with creating the CSS for the animation. This animation will last for 3 seconds, be called “slidein”, repeat 3 times, and alternate direction each time. In the {{cssxref("@keyframes")}}, the width and margin-left are manipulated to make the element slide across the screen.</p>

<pre class="brush: css notranslate">.slidein {
  animation-duration: 3s;
  animation-name: slidein;
  animation-iteration-count: 3;
  animation-direction: alternate;
}

@keyframes slidein {
  from {
    margin-left:100%;
    width:300%
  }

  to {
    margin-left:0%;
    width:100%;
  }
}</pre>

<h4 id="Adding_the_animation_event_listeners">Adding the animation event listeners</h4>

<p>We’ll use JavaScript code to listen for all three possible animation events. This code configures our event listeners; we call it when the document is first loaded in order to set things up.</p>

<pre class="brush: js notranslate">var element = document.getElementById("watchme");
element.addEventListener("animationstart", listener, false);
element.addEventListener("animationend", listener, false);
element.addEventListener("animationiteration", listener, false);

element.className = "slidein";
</pre>

<p>This is pretty standard code; you can get details on how it works in the documentation for {{domxref("eventTarget.addEventListener()")}}. The last thing this code does is set the <code>class</code> on the element we'll be animating to “slidein”; we do this to start the animation.</p>

<p>Why? Because the <code>animationstart</code> event fires as soon as the animation starts, and in our case, that happens before our code runs. So we’ll start the animation ourselves by setting the class of the element to the style that gets animated after the fact.</p>

<h4 id="Receiving_the_events">Receiving the events</h4>

<p>The events get delivered to the <code>listener()</code> function, which is shown below.</p>

<pre class="brush: js notranslate">function listener(event) {
  var l = document.createElement("li");
  switch(event.type) {
    case "animationstart":
      l.textContent = `Started: elapsed time is ${event.elapsedTime}`;
      break;
    case "animationend":
      l.textContent = `Ended: elapsed time is ${event.elapsedTime}`;
      break;
    case "animationiteration":
      l.textContent = `New loop started at time ${event.elapsedTime}`;
      break;
  }
  document.getElementById("output").appendChild(l);
}
</pre>

<p>This code, too, is very simple. It looks at the {{domxref("event.type")}} to determine which kind of animation event occurred, then adds an appropriate note to the {{HTMLElement("ul")}} (unordered list) we’re using to log these events.</p>

<p>The output, when all is said and done, looks something like this:</p>

<ul>
 <li>Started: elapsed time is 0</li>
 <li>New loop started at time 3.01200008392334</li>
 <li>New loop started at time 6.00600004196167</li>
 <li>Ended: elapsed time is 9.234000205993652</li>
</ul>

<p>Note that the times are very close to, but not exactly, those expected given the timing established when the animation was configured. Note also that after the final iteration of the animation, the <code>animationiteration</code> event isn’t sent; instead, the <code>animationend</code> event is sent.</p>

<h4 id="The_HTML">The HTML</h4>

<p>Just for the sake of completeness, here’s the HTML that displays the page content, including the list into which the script inserts information about the received events:</p>

<pre class="brush: html notranslate">&lt;h1 id="watchme"&gt;Watch me move&lt;/h1&gt;
&lt;p&gt;
  This example shows how to use CSS animations to make &lt;code&gt;H1&lt;/code&gt;
  elements move across the page.
&lt;/p&gt;
&lt;p&gt;
  In addition, we output some text each time an animation event fires,
  so you can see them in action.
&lt;/p&gt;
&lt;ul id="output"&gt;
&lt;/ul&gt;
</pre>

<p>And here's the live output.</p>

<div class="notecard note">
<p><strong>Note</strong>: Reload page to see the animation, or click the CodePen button to see the animation in the CodePen environment.</p>
</div>

<p>{{EmbedLiveSample('Using_animation_events', '600', '300')}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("AnimationEvent", "AnimationEvent")}}</li>
 <li><a href="/en-US/docs/CSS/CSS_animations/Detecting_CSS_animation_support" title="en/CSS/CSS animations/Detecting CSS animation support">Detecting CSS animation support</a></li>
 <li><a href="/en-US/docs/Web/Guide/CSS/Using_CSS_transitions">Using CSS transitions</a></li>
</ul>
